JAVA基础再回首(十九)——异常的概述、Try…Catch、多异常处理、Throws、throw、finally、自定义异常及异常的注意事项

原创 2016年09月03日 13:48:38

JAVA基础再回首(十九)——异常的概述、Try…Catch、多异常处理、Throws、throw、finally、自定义异常及异常的注意事项

版权声明:转载必须注明本文转自程序员杜鹏程的博客:http://blog.csdn.net/m366917


前面我们学习了集合,现在我们开始IO流的学习
学习io流之前呢,我们先来学习异常

异常的概述

  • 异常概述
    • 异常就是Java程序在运行过程中出现的错误。
  • 由来
    • 问题也是现实生活中一个具体事务,也可以通过java 的类的形式进行描述,并封装成对象。
    • 其实就是Java对不正常情况进行描述后的对象体现。

异常的分类图解

这里写图片描述

从上面的图我们可以看到:程序的异常Throwable分为两类

  • 程序的异常:Throwable
    • 严重问题:Error 我们不处理。这种问题一般都是很严重的,比如说内存溢出。
    • 问题:Exception
      • 编译期问题:不是RuntimeException的异常 必须进行处理的,因为你不处理,编译就不能通过。
      • 运行期问题:RuntimeException 这种问题我们也不处理,因为是你的问题,而且这个问题出现肯定是我们的代码不够严谨,需要修正代码的。

如何程序出现了问题,我们没有做任何处理,最终jvm会做出默认的处理。
把异常的名称,原因及出现的问题等信息输出在控制台。

public class ExceptionDemo {
    public static void main(String[] args) {

        int a = 10;
        int b = 0;
        System.out.println(a / b);

        System.out.println("over");
    }
}

这里写图片描述
我们运行程序,可以看到异常出现了。它为什么会出现异常呢?


  • JVM的默认处理方案
    • 把异常的名称,错误原因及异常出现的位置等信息输出在了控制台
    • 程序停止执行

我们在来理解一下JVM的默认处理方案

jvm发现运算是已经违反了数学运算规则,java将这种常见的问题进行描述,并封装成了对象叫做ArithmeticException
当除0运算发生后,jvm将该问题打包成了一个异常对象.
并将对象抛给调用者main函数,new ArithmeticException(“/by zero”);

main函数收到这个问题时,有两种处理方式:
1. 自己将该问题处理,然后继续运行
2.自己没有针对的处理方式,只有交给调用main的jvm来处理

jvm有一个默认的异常处理机制,就将该异常进行处理.并将该异常的名称,异常的信息.异常出现的位置打印在了控制台上
同时将程序停止运行

Try…Catch

那么我们自己如何处理异常呢?

  • 异常的处理方案
    • try…catch…finally
    • throws
 try...catch...finally的处理格式:
        try {
            可能出现问题的代码;
        }catch(异常名 变量) {
            针对问题的处理;
        }finally {
            释放资源;
        }
  变形格式:
        try {
            可能出现问题的代码;
        }catch(异常名 变量) {
            针对问题的处理;
        }

注意:
try里面的代码越少越好
catch里面必须有内容,哪怕是给出一个简单的提示

那么我们就来处理一下上面的异常吧

public class ExceptionDemo {
    public static void main(String[] args) {

        int a = 10;
        int b = 0;

        try {
            System.out.println(a / b);
        } catch (ArithmeticException ae) {
            System.out.println("除数不能为0");
        }

        System.out.println("over");
    }
}

我们运行程序看控制台
这里写图片描述

多异常处理

上面我们处理了一个简单的异常,如果我们遇到一个复杂的程序需要我们处理多个异常要怎么办呢?下面我们来学习

  • 多异常的处理

    • 每一个写一个try…catch(这样有点过于麻烦)
    • 写一个try,多个catch
            try{
                ...
            }catch(异常类名 变量名) {
                ...
            }
            catch(异常类名 变量名) {
                ...
            }
            ...
            //注意事项:
                1:能明确的尽量明确,不要用大的来处理。
                2:平级关系的异常谁前谁后无所谓,如果出现了子父关系,父必须在后面。
public class ExceptionDemo {
    public static void main(String[] args) {
         method();
         System.out.println("----------");
        methods();
    }

    // 两个异常的处理
    public static void method() {
        int a = 10;
        int b = 0;
        int[] arr = { 1, 2, 3 };

        try {
            System.out.println(arr[3]);
            System.out.println(a / b);
        } catch (ArithmeticException e) {
            System.out.println("除数不能为0");
        } catch (ArrayIndexOutOfBoundsException e) {
            System.out.println("你访问了不该的访问的索引");
        }

        System.out.println("over");
    }
    //多个异常的处理
    public static void methods() {
        int a = 10;
        int b = 0;
        int[] arr = { 1, 2, 3 };

        try {
            System.out.println(a / b);
            System.out.println(arr[3]);
            System.out.println("这里出现了一个异常");
        } catch (ArithmeticException e) {
            System.out.println("除数不能为0");
        } catch (ArrayIndexOutOfBoundsException e) {
            System.out.println("你访问了不该的访问的索引");
        } catch (Exception e) {
            System.out.println("出问题了");
        }

        System.out.println("over");
    }
}

我们运行程序看结果
这里写图片描述

我们看结果可以总结以下经验
一旦try里面出了问题,就会在这里把问题给抛出去,然后和catch里面的问题进行匹配,一旦有匹配的,就执行catch里面的处理,然后结束了try…catch继续执行后面的语句。

Throwable中的方法

  • getMessage():获取异常信息,返回字符串。
  • toString():获取异常类名和异常信息,返回字符串。
  • printStackTrace():获取异常类名和异常信息,以及异常出现在程序中的位置。返回值void。
  • printStackTrace(PrintStream s):通常用该方法将异常内容保存在日志文件中,以便查阅。

异常声明Throws

有些时候,我们是可以对异常进行处理的,但是又有些时候,我们根本就没有权限去处理某个异常。或者说,我处理不了,我就不处理了。
为了解决出错问题,Java针对这种情况,就提供了另一种处理方案:抛出。

  • 格式:
    • throws 异常类名
    • 注意:这个格式必须跟在方法的括号后面。
public class ExceptionDemo {
    public static void main(String[] args) {
        System.out.println("今天天气很好");
        try {
            method();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        System.out.println("但是我要在家学习");

        method2();
    }

    // 编译期异常的抛出,编译不通过,我们就要抛出异常了
    public static void method() throws ParseException  {
        String s = "2016-09-03";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date d = sdf.parse(s);
        System.out.println(d);
    }

    // 运行期异常的抛出
    public static void method2() throws ArithmeticException {
        int a = 10;
        int b = 0;
        System.out.println(a / b);
    }

}

运行结果
这里写图片描述

在编译期异常会提示给我们让我们进行处理
这里写图片描述
如果我们只是抛出了异常,那么我们调用方法时,还是要处理这个异常的,看下图
这里写图片描述

所以呢,我们就得出一下结论:

  • 编译期异常抛出,将来调用者必须处理。
  • 运行期异常抛出,将来调用可以不用处理。

throw

上面讲了throws,那么throw又是什么鬼,怎么用,他们有什么区别呢,让我们带着疑问出发

先了解他的概念:
throw:在功能方法内部出现某种情况,程序不能继续运行,需要进行跳转时,就用throw把异常对象抛出。如果出现了异常情况,我们可以把该异常抛出,这个时候的抛出的应该是异常的对象。

throws和throw的区别

  • throws

    • 用在方法声明后面,跟的是异常类名
    • 可以跟多个异常类名,用逗号隔开
    • 表示抛出异常,由该方法的调用者来处理
    • throws表示出现异常的一种可能性,并不一定会发生这些异常
  • throw

    • 用在方法体内,跟的是异常对象名
    • 只能抛出一个异常对象名
    • 表示抛出异常,由方法体内的语句处理
    • throw则是抛出了异常,执行throw则一定抛出了某种异常

学了这么多异常的处理,那么我们到底该如何处理异常呢?我们来总结一下

  • 原则:如果该功能内部可以将问题处理,用try,如果处理不了,交由调用者处理,这是用throws
  • 区别:
    • 后续程序需要继续运行就try
    • 后续程序不需要继续运行就throws

finally

  • finally的特点
    • 被finally控制的语句体一定会执行
    • 特殊情况:在执行到finally之前jvm退出了(比如System.exit(0))
  • finally的作用
    • 用于释放资源,在IO流操作和数据库操作中会见到(我们后面学习中会看到)

finally的用法很简单,这里就不举例了,我们看一个关于finally典型的题

final,finally和finalize的区别?

  • final
    • 最终的意思,可以修饰类,成员变量,成员方法
    • 修饰类,类不能被继承
    • 修饰变量,变量是常量
    • 修饰方法,方法不能被重写
  • finally
    • 是异常处理的一部分,用于释放资源。
    • 一般来说,代码肯定会执行,特殊情况:在执行到finally之前jvm退出了
  • finalize
    • 是Object类的一个方法,用于垃圾回收

这个题的难点就在于finalize,我们很少了解

自定义异常

java不可能对所有的情况都考虑到,所以,在实际的开发中,我们可能需要自己定义异常。而我们自己随意的写一个类,是不能作为异常类来看的,要想你的类是一个异常类,就必须继承自Exception或者RuntimeException

/*
 * 自定义异常测试类
 */
public class StudentDemo {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        System.out.println("请输入学生成绩:");
        int score = sc.nextInt();

        Teacher t = new Teacher();
        try {
            t.check(score);
        } catch (MyException e) {
            e.printStackTrace();
        }
    }
}

/*
 *自定义
 */
class MyException extends Exception {
    public MyException() {
    }

    public MyException(String message) {
        super(message);
    }
}
//老师类
class Teacher {
    public void check(int score) throws MyException {
        if (score > 100 || score < 0) {
            throw new MyException("分数必须在0-100之间");
        } else {
            System.out.println("分数没有问题");
        }
    }

运行程序,我们在控制台输出一个大于100的数,就会有异常
这里写图片描述
是不是感觉很好玩呢

异常注意事项

我们来学习最后一个知识点

  • 子类重写父类方法时,子类的方法必须抛出相同的异常或父类异常的子类。
  • 如果父类抛出了多个异常,子类重写父类时,只能抛出相同的异常或者是他的子集,子类不能抛出父类没有的异常
  • 如果被重写的方法没有异常抛出,那么子类的方法绝对不可以抛出异常,如果子类方法内有异常发生,那么子类只能try,不能throws

好了,异常我们就了解这么多吧,我们要领悟java的思想

欢迎有兴趣的同学加我朋友的QQ群:点击直接加群555974449 请备注:java基础再回首我们一起来玩吧。

版权声明:本文为博主原创文章,未经博主允许不得转载。

JAVA之旅(十)——异常的概述,Try-Catch,异常声明Throws,多异常处理,自定义异常,Throw和Throws的区别

JAVA之旅(十)——异常的概述,Try-Catch,异常声明Throws,多异常处理,自定义异常,Throw和Throws的区别 不知不觉,JAVA之旅这个系列已经更新到第十篇了,感觉如梦如幻,...
  • qq_26787115
  • qq_26787115
  • 2016年05月30日 20:54
  • 4995

关于try-catch、throw、finally在异常时的执行顺序

package test; //jdk 1.8 public class TestException1 { /** * catch中的return和throw是不能共存的(无论谁先谁后都编...
  • rainyspring4540
  • rainyspring4540
  • 2017年01月05日 11:04
  • 697

Swift 中异常抛出和四种异常处理

在Swift中你可以像其他语言一样抛出异常处理异常,今天我们就详细地说说Swift中的异常抛出和处理。 在一开始我们要定义错误或者说是异常,Swift中的一些简单异常可以使用枚举定义,注意这个枚举要...
  • qq_30970529
  • qq_30970529
  • 2016年10月09日 14:35
  • 7381

finally中使用return会吃掉catch中抛出的异常

如果把return和throw放在一起,直接会提示错误。"Unreachable statement"(无法被执行). 然而finally却可以成功骗过编译器让两者并存(是不是可以算是编译器的一个小b...
  • tiantiandjava
  • tiantiandjava
  • 2015年07月06日 17:30
  • 6122

C#中的异常捕获机制(try catch finally)

转载自:http://blog.csdn.net/zevin/article/details/6901489 一、C#的异常处理所用到关键字 try 用于检查发生的异常,并帮助发送任何可能的异...
  • u013028876
  • u013028876
  • 2016年01月16日 16:55
  • 1871

throw、try块和异常处理总结

标准库异常类定义在四个头文件中: 1、exception头文件中定义了最常见的异常类,类名是exception,这个类只通知异常的产生,不会提供更多的信息 2、stdexcept头文件中定义了以下...
  • zhang2008rongping
  • zhang2008rongping
  • 2015年04月18日 22:24
  • 687

java中的异常以及 try catch finally以及finally的执行顺序

java try、catch、finally及finally执行顺序详解 1.为什么要用finally 先看一个没有finally的异常处理try-catch语句: 假设count...
  • QH_JAVA
  • QH_JAVA
  • 2013年10月21日 21:43
  • 14136

java里面try,catch,finally异常捕捉

java里面try,catch,finally异常捕捉程序块出现异常,需要用try,catch来捕捉,形如: try{ //代码区 }catch(Exception e){ //异常处理 }...
  • yizeshun
  • yizeshun
  • 2015年11月05日 15:21
  • 1605

java 异常捕捉 ( try catch finally ) 你真的掌握了吗?

前言: java 中的异常处理机制你真的理解了吗?掌握了吗? catch 体里遇到 return 是怎么处理? finally 体遇到 return 怎么办?finally 体里有 System....
  • Lu_Ca
  • Lu_Ca
  • 2016年08月11日 17:00
  • 8318

Java异常及异常块执行次序(try、catch、finally、return)

Java异常: ①使用try-catch-finally处理异常; ②使用throw、throws抛出异常; ③上边为java异常处理5个关键字。 异常是程序在设计时或运行时产生的错误,异常处理是处理...
  • typa01_kk
  • typa01_kk
  • 2015年04月16日 23:50
  • 1959
内容举报
返回顶部
收藏助手
不良信息举报
您举报文章:JAVA基础再回首(十九)——异常的概述、Try…Catch、多异常处理、Throws、throw、finally、自定义异常及异常的注意事项
举报原因:
原因补充:

(最多只允许输入30个字)